VS2019中CMake项目如何指定c++语言标准

2020-02-15 10:01:37 来源:易采站长站 作者:于海丽

VS2019中CMake项目怎么指定语言标准

博主前几天在使用c++17新特性结构绑定时报错了,代码如下:

#include<bits/stdc++.h>
using namespace std;
int main() {
  unordered_map<int, int> mmid;
  for (auto [a, b] : mmid) {
    cout << a << ' ' << b << endl;
  }
  return 0;
}

后来查了一下发现CMake项目默认的c++语言标准是低于17的,所以就得指定一下语言版本才行。

有两种设置方法。第一种可以设置默认使用最新的语言标准。代码如下,添加到CMakeLists.txt文件中即可。

if (MSVC_VERSION GREATER_EQUAL "1900")
  include(CheckCXXCompilerFlag)
  CHECK_CXX_COMPILER_FLAG("/std:c++latest" _cpp_latest_flag_supported)
  if (_cpp_latest_flag_supported)
    add_compile_options("/std:c++latest")
  endif()
endif()

不过上面的方法太过于繁琐,不过没关系还有第二种更简洁的方法,只需要一行代码就可搞定。

set(CMAKE_CXX_STANDARD 17)

这样就能执行使用c++17这个标准了。如果想使用其他版本的语言标注,将17替换成对应版本即可。

PS:特别注意,添加上诉代码一定要放在CMakeLists文件的开头位置,不然是无效的。

cmake指定c++编译版本

修改 CMakeLists.txt 文件,添加如下命令

SET(CMAKE_C_COMPILER "/home/public/local/bin/gcc")

SET(CMAKE_CXX_COMPILER "/home/public/local/bin/g++")

Cmake编译使用C++11

cmake编译项目需要C++11特性的支持,只需要在CMakeLists.txt中加入:

add_definitions(-std=c++11)

这篇文章就介绍到这了,希望大家以后多多支持易采站长站。

微信扫一扫

易采站长站微信账号